Package: DelayedRandomArray
Version: 1.20.0
Date: 2024-07-05
Title: Delayed Arrays of Random Values
Description: 
    Implements a DelayedArray of random values where the realization of the sampled values is delayed until they are needed.
    Reproducible sampling within any subarray is achieved by chunking where each chunk is initialized with a different random seed and stream.
    The usual distributions in the stats package are supported, along with scalar, vector and arrays for the parameters.
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: GPL-3
Depends: SparseArray (>= 1.5.15), DelayedArray (>= 0.31.6)
Imports: methods, dqrng, Rcpp
LinkingTo: dqrng, BH, Rcpp
Suggests: testthat, knitr, BiocStyle, rmarkdown, Matrix
biocViews: DataRepresentation
BugReports: https://github.com/LTLA/DelayedRandomArray/issues
URL: https://github.com/LTLA/DelayedRandomArray
SystemRequirements: C++11
VignetteBuilder: knitr
RoxygenNote: 7.3.2
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/DelayedRandomArray
git_branch: RELEASE_3_23
git_last_commit: e4e339e
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:40:23 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

#' DelayedArray of random exponential values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of exponentially distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param rate Numeric vector used as \code{rate} in \code{\link{qexp}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomExpArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomExpArray object,
#' containing random draws from a exponential distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomExpArray-class
#' RandomExpArraySeed-class
#' RandomExpMatrix-class
#' sampleDistrParam,RandomExpArraySeed-method
#' sampleDistrFun,RandomExpArraySeed-method
#' matrixClass,RandomExpArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomExpArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomExpArraySeed(c(1e5, 1e5), rate=runif(1e5))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' rate <- rsparsematrix(1e5, 1e5, density=0.00001)
#' rate <- abs(DelayedArray(rate)) + 1
#' X3 <- RandomExpArraySeed(c(1e5, 1e5), rate=rate)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomExpArray-class
NULL

#' @export
#' @rdname RandomExpArray-class
RandomExpArraySeed <- function(dim, rate=1, chunkdim=NULL) {
    new("RandomExpArraySeed", dim=dim, rate=rate, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomExpArraySeed", function(x) "rate")

#' @export
setMethod("sampleDistrFun", "RandomExpArraySeed", function(x) stats::qexp)

#' @export
setMethod("matrixClass", "RandomExpArray", function(x) "RandomExpMatrix")

#' @export
#' @rdname RandomExpArray-class
setMethod("DelayedArray", "RandomExpArraySeed", function(seed) new_DelayedArray(seed, Class="RandomExpArray"))

#' @export
#' @rdname RandomExpArray-class
RandomExpArray <- function(dim, rate=1, chunkdim=NULL) {
    DelayedArray(RandomExpArraySeed(dim, rate, chunkdim=chunkdim))
}

#' DelayedArray of random Cauchy-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Cauchy-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param location,scale Numeric vector used as the argument of the same name in \code{\link{qcauchy}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomCauchyArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomCauchyArray object,
#' containing random draws from a Cauchy distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomCauchyArray-class
#' RandomCauchyArraySeed-class
#' RandomCauchyMatrix-class
#' sampleDistrParam,RandomCauchyArraySeed-method
#' sampleDistrFun,RandomCauchyArraySeed-method
#' matrixClass,RandomCauchyArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomCauchyArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomCauchyArraySeed(c(1e5, 1e5), location=runif(1e5))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' loc <- rsparsematrix(1e5, 1e5, density=0.00001)
#' X3 <- RandomCauchyArraySeed(c(1e5, 1e5), location=loc)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomCauchyArray-class
NULL

#' @export
#' @rdname RandomCauchyArray-class
RandomCauchyArraySeed <- function(dim, location=0, scale=1, chunkdim=NULL) {
    new("RandomCauchyArraySeed", dim=dim, location=location, scale=scale, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomCauchyArraySeed", function(x) c("location", "scale"))

#' @export
setMethod("sampleDistrFun", "RandomCauchyArraySeed", function(x) stats::qcauchy)

#' @export
setMethod("matrixClass", "RandomCauchyArray", function(x) "RandomCauchyMatrix")

#' @export
#' @rdname RandomCauchyArray-class
setMethod("DelayedArray", "RandomCauchyArraySeed", function(seed) new_DelayedArray(seed, Class="RandomCauchyArray"))

#' @export
#' @rdname RandomCauchyArray-class
RandomCauchyArray <- function(dim, location=0, scale=1, chunkdim=NULL) {
    DelayedArray(RandomCauchyArraySeed(dim, location=location, scale=scale, chunkdim=chunkdim))
}

#' DelayedArray of random log-normal values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of log-normally distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param location,scale Numeric vector used as the argument of the same name in \code{\link{qlogis}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomLogisArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomLogisArray object,
#' containing random draws from a log-normal distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomLogisArray-class
#' RandomLogisArraySeed-class
#' RandomLogisMatrix-class
#' sampleDistrParam,RandomLogisArraySeed-method
#' sampleDistrFun,RandomLogisArraySeed-method
#' matrixClass,RandomLogisArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomLogisArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomLogisArraySeed(c(1e5, 1e5), location=runif(1e5), scale=runif(1e5))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' location <- rsparsematrix(1e5, 1e5, density=0.00001)
#' X3 <- RandomLogisArraySeed(c(1e5, 1e5), location=location)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomLogisArray-class
NULL

#' @export
#' @rdname RandomLogisArray-class
RandomLogisArraySeed <- function(dim, location=0, scale=1, chunkdim=NULL) {
    new("RandomLogisArraySeed", dim=dim, location=location, scale=scale, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomLogisArraySeed", function(x) c("location", "scale"))

#' @export
setMethod("sampleDistrFun", "RandomLogisArraySeed", function(x) stats::qlogis)

#' @export
setMethod("matrixClass", "RandomLogisArray", function(x) "RandomLogisMatrix")

#' @export
#' @rdname RandomLogisArray-class
setMethod("DelayedArray", "RandomLogisArraySeed", function(seed) new_DelayedArray(seed, Class="RandomLogisArray"))

#' @export
#' @rdname RandomLogisArray-class
RandomLogisArray <- function(dim, location=0, scale=1, chunkdim=NULL) {
    DelayedArray(RandomLogisArraySeed(dim, location, scale, chunkdim=chunkdim))
}

#' DelayedArray of random Wilcoxon-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Wilcoxon-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomWilcoxArraySeed object.
#' @param m,n Numeric vector used as the argument of the same name in \code{\link{qwilcox}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomWilcoxArray object,
#' containing random draws from a Wilcox distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomWilcoxArray-class
#' RandomWilcoxArraySeed-class
#' RandomWilcoxMatrix-class
#' sampleDistrParam,RandomWilcoxArraySeed-method
#' sampleDistrFun,RandomWilcoxArraySeed-method
#' matrixClass,RandomWilcoxArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomWilcoxArraySeed(c(1e5, 1e5), m=10, n=20)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomWilcoxArraySeed(c(1e5, 1e5), m=round(runif(1e5, 10, 20)), n=20)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' m <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
#' X3 <- RandomWilcoxArraySeed(c(1e5, 1e5), m=m, n=50)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomWilcoxArray-class
NULL

#' @export
#' @rdname RandomWilcoxArray-class
RandomWilcoxArraySeed <- function(dim, m, n, chunkdim=NULL, sparse=FALSE) {
    new("RandomWilcoxArraySeed", dim=dim, m=m, n=n, chunkdim=chunkdim, sparse=sparse)
}

#' @export
setMethod("sampleDistrParam", "RandomWilcoxArraySeed", function(x) c("m", "n"))

#' @export
setMethod("sampleDistrFun", "RandomWilcoxArraySeed", function(x) stats::qwilcox)

#' @export
setMethod("matrixClass", "RandomWilcoxArray", function(x) "RandomWilcoxMatrix")

#' @export
#' @rdname RandomWilcoxArray-class
setMethod("DelayedArray", "RandomWilcoxArraySeed", function(seed) new_DelayedArray(seed, Class="RandomWilcoxArray"))

#' @export
#' @rdname RandomWilcoxArray-class
RandomWilcoxArray <- function(dim, m, n, chunkdim=NULL) {
    DelayedArray(RandomWilcoxArraySeed(dim, m=m, n=n, chunkdim=chunkdim))
}

#' DelayedArray of random uniform values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of uniformly distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param min,max Numeric vector used as \code{min} and \code{max}, respectively, in \code{\link{qunif}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomUnifArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomUnifArray object,
#' containing random draws from a uniform distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomUnifArray-class
#' RandomUnifArraySeed-class
#' RandomUnifMatrix-class
#' sampleDistrParam,RandomUnifArraySeed-method
#' sampleDistrFun,RandomUnifArraySeed-method
#' matrixClass,RandomUnifArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomUnifArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomUnifArraySeed(c(1e5, 1e5), min=1:1e5, max=1:1e5*2)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' min <- rsparsematrix(1e5, 1e5, density=0.00001)
#' X3 <- RandomUnifArraySeed(c(1e5, 1e5), min=min, max=DelayedArray(min)+1)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomUnifArray-class
NULL

#' @export
#' @rdname RandomUnifArray-class
RandomUnifArraySeed <- function(dim, min=0, max=1, chunkdim=NULL) {
    new("RandomUnifArraySeed", dim=dim, min=min, max=max, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomUnifArraySeed", function(x) c("min", "max"))

#' @export
setMethod("sampleDistrFun", "RandomUnifArraySeed", function(x) stats::qunif)

#' @export
setMethod("matrixClass", "RandomUnifArray", function(x) "RandomUnifMatrix")

#' @export
#' @rdname RandomUnifArray-class
setMethod("DelayedArray", "RandomUnifArraySeed", function(seed) new_DelayedArray(seed, Class="RandomUnifArray"))

#' @export
#' @rdname RandomUnifArray-class
RandomUnifArray <- function(dim, min=0, max=1, chunkdim=NULL) {
    DelayedArray(RandomUnifArraySeed(dim, min, max, chunkdim=chunkdim))
}

# This tests the various specific distributions.
# library(testthat); library(DelayedRandomArray); source("test-distr.R")

FUN <- function(class, distr, defaults, ranges, has.sparse=FALSE) {
    set.seed(999)
    d <- c(100L, 50L)
    ref <- RandomUnifArray(d)
    constructor <- get(class)

    args0 <- as.list(defaults)

    for (p in names(ranges)) {
        r <- ranges[[p]]
        args <- args0

        # Scalar:
        set.seed(999)
        args[[p]] <- r[1]
        out <- do.call(constructor, c(list(d), args))
        expect_identical(dim(out), d)
        expect_identical(as.vector(out), do.call(distr, c(list(as.vector(ref)), args)))
        expect_false(is_sparse(out))

        if (has.sparse) {
            set.seed(999)
            out2 <- do.call(constructor, c(list(d), args, list(sparse=TRUE)))
            expect_true(is_sparse(out2))
            expect_identical(dim(out2), d)
            expect_identical(as.vector(out2), as.vector(out))
        }

        # Vector:
        args[[p]] <- runif(d[1], r[1], r[2])
        if (is.integer(r)) {
            args[[p]] <- round(args[[p]])
        }

        set.seed(999)
        out <- do.call(constructor, c(list(d), args))
        expect_identical(dim(out), d)
        expect_identical(as.vector(out), do.call(distr, c(list(as.vector(ref)), args)))

        # Array.
        args[[p]] <- RandomUnifArray(d, min=r[1], max=r[2])
        if (is.integer(r)) {
            args[[p]] <- round(args[[p]])
        }

        set.seed(999)
        out <- do.call(constructor, c(list(d), args))
        expect_identical(dim(out), d)
        expect_identical(as.vector(out), do.call(distr, c(list(as.vector(ref)), lapply(args, as.vector))))
    }
}

test_that("Beta works as expected", {
    FUN("RandomBetaArray", qbeta, list(shape1=1, shape2=1), ranges=list(shape1=c(1, 5), shape2=c(1, 10), ncp=c(0, 2)))
})

test_that("Binom works as expected", {
    FUN("RandomBinomArray", qbinom, list(size=5, prob=0.5), ranges=list(size=c(1L, 5L), prob=c(0, 1)), has.sparse=TRUE)
})

test_that("Cauchy works as expected", {
    FUN("RandomCauchyArray", qcauchy, list(), ranges=list(location=c(-1, 1), scale=c(0.5, 5)))
})

test_that("Exp works as expected", {
    FUN("RandomExpArray", qexp, list(), ranges=list(rate=c(0.5, 10)))
})

test_that("F works as expected", {
    FUN("RandomFArray", qf, list(df1=1, df2=10), ranges=list(df1=c(1, 10), df2=c(5, 20), ncp=c(1, 5)))
})

test_that("Gamma works as expected", {
    FUN("RandomGammaArray", qgamma, list(shape=5), ranges=list(shape=c(1, 10), rate=c(1, 10), scale=c(1, 10)))
})

test_that("Geom works as expected", {
    FUN("RandomGeomArray", qgeom, list(), ranges=list(prob=c(0.01, 0.99)), has.sparse=TRUE)
})

test_that("Hyper works as expected", {
    FUN("RandomHyperArray", qhyper, list(m=10, n=7, k=8), ranges=list(m=c(5L, 20L), n=c(5L, 20L), k=c(5L, 10L)), has.sparse=TRUE)
})

test_that("Lnorm works as expected", {
    FUN("RandomLnormArray", qlnorm, list(), ranges=list(meanlog=c(0, 5), sdlog=c(0.1, 10)))
})

test_that("Logis works as expected", {
    FUN("RandomLogisArray", qlogis, list(), ranges=list(location=c(0, 5), scale=c(0.1, 10)))
})

test_that("Nbinom works as expected", {
    FUN("RandomNbinomArray", qnbinom, list(size=10, prob=0.5), ranges=list(size=c(0.1, 100), prob=c(0.1, 0.9)))

    FUN("RandomNbinomArray", qnbinom, list(size=10), ranges=list(mu=c(0.1, 100)), has.sparse=TRUE)
})

test_that("Norm works as expected", {
    FUN("RandomNormArray", qnorm, list(), ranges=list(mean=c(-5, 5), sd=c(0.1, 10)))
})

test_that("Pois works as expected", {
    FUN("RandomPoisArray", qpois, list(), ranges=list(lambda=c(1, 100)), has.sparse=TRUE)
})

test_that("T works as expected", {
    FUN("RandomTArray", qt, list(df=10), ranges=list(df=c(5, 50), ncp=c(0, 100)))
})

test_that("Unif works as expected", {
    FUN("RandomUnifArray", qunif, list(), ranges=list(min=c(-2, -1), max=c(3, 5)))
})

test_that("Weibull works as expected", {
    FUN("RandomWeibullArray", qweibull, list(shape=10), ranges=list(shape=c(5, 50), scale=c(0.5, 10)))
})

test_that("Wilcox works as expected", {
    FUN("RandomWilcoxArray", qwilcox, list(m=10, n=5), ranges=list(m=c(5L, 50L), n=c(2L, 10L)))
})

# This tests the base class utilities.
# library(DelayedRandomArray); library(testthat); source("test-class.R")

test_that("class construction works as expected", {
    arr <- RandomUnifArray(c(100, 50, 20))
    expect_identical(dim(arr), c(100L, 50L, 20L))
    expect_type(chunkdim(arr), "integer")
    expect_false(is_sparse(arr))

    expect_error(RandomUnifArray(c(100, 50, 20), chunkdim=c(-1,0,0)), "non-negative")
    expect_error(RandomUnifArray(c(100, 50, 20), chunkdim=c(0,0,0)), "positive")
    expect_error(RandomUnifArray(c(100, 50, 20), chunkdim=c(0,0)), "same length")
    expect_error(RandomUnifArray(c(100, 50, 20), chunkdim=c(100,100,100)), "larger")

    expect_output(show(arr), "RandomUnifArray")

    mat <- RandomUnifArray(c(100, 50))
    expect_output(show(mat), "RandomUnifMatrix")
})

test_that("subsetting works as expected", {
    full <- RandomUnifArray(c(100, 50, 20))
    ref <- as.array(full)

    expect_identical(ref[1:10,1:10,], as.array(full[1:10,1:10,]))

    # Non-contiguous slices.
    expect_identical(ref[1:10*10,1:10*5,], as.array(full[1:10*10,1:10*5,]))

    # Unordered slices. 
    chosen1 <- sample(100, 10)
    chosen2 <- sample(50, 20)
    expect_identical(ref[chosen1,chosen2,], as.array(full[chosen1,chosen2,]))

    chosen1 <- sort(chosen1, decreasing=TRUE)
    expect_identical(ref[chosen1,chosen2,], as.array(full[chosen1,chosen2,]))

    # Duplicates.
    chosen1 <- sample(10, 100, replace=TRUE)
    chosen2 <- sample(50, 100, replace=TRUE)
    expect_identical(ref[chosen1,chosen2,], as.array(full[chosen1,chosen2,]))

    # Works for the third dimension.
    expect_identical(ref[,,10:1], as.array(full[,,10:1]))
})

test_that("chunking behaves predictably", {
    arr <- RandomUnifArray(c(1000, 1000))
    expect_identical(chunkdim(arr), c(100L, 100L))

    # Scales with large chunks.
    arr <- RandomUnifArray(c(40000, 10000))
    expect_identical(chunkdim(arr), c(200L, 100L))

    # Handles small chunks.
    arr <- RandomUnifArray(c(50, 10))
    expect_identical(chunkdim(arr), c(50L, 10L))

    # Handles custom chunks.
    arr <- RandomUnifArray(c(100, 100), chunkdim=c(100, 1L))
    expect_identical(chunkdim(arr), c(100L, 1L))
})

test_that("parameter handling works as expected", {
    # Handles scalars.
    arr <- RandomUnifArray(c(100, 50), min=1, max=5)
    expect_identical(sampleDistrParam(seed(arr)), c("min", "max"))
    expect_true(all(arr > 1))
    expect_true(all(arr < 5))

    # Handles vectors.
    set.seed(100)
    arr <- RandomUnifArray(c(100, 50))

    set.seed(100)
    arr2 <- RandomUnifArray(c(100, 50), min=1:100/20, max=5)
    expect_identical(as.vector(arr2), qunif(as.vector(arr), 1:100/20, 5))

    set.seed(100)
    arr2 <- RandomUnifArray(c(100, 50), min=1:20/5, max=5)
    expect_identical(as.vector(arr2), qunif(as.vector(arr), 1:20/5, 5))

    set.seed(100)
    expect_warning(arr2 <- RandomUnifArray(c(100, 50), min=1:30/6, max=5), "multiple")
    expect_identical(as.vector(arr2), qunif(as.vector(arr), 1:30/6, 5))

    set.seed(100)
    MIN <- matrix(1:5000/1000, 100, 50)
    arr2 <- RandomUnifArray(c(100, 50), min=MIN, max=5)
    expect_identical(as.vector(arr2), qunif(as.vector(arr), as.vector(MIN), 5))

    expect_error(RandomUnifArray(c(100, 50), min=MIN[,1:10], max=5), "must be the same")
})

#' DelayedArray of random F-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of F-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param df,ncp Numeric vector used as the argument of the same name in \code{\link{qf}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#'
#' If \code{ncp} is missing, a central T distribution is assumed.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomTArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomTArray object,
#' containing random draws from a exponential distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomTArray-class
#' RandomTArraySeed-class
#' RandomTMatrix-class
#' sampleDistrParam,RandomTArraySeed-method
#' sampleDistrFun,RandomTArraySeed-method
#' matrixClass,RandomTArray-method
#' extract_array,RandomTArraySeed-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomTArraySeed(c(1e5, 1e5), df=10)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomTArraySeed(c(1e5, 1e5), df=sample(20, 1e5, replace=TRUE))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' ncp <- rsparsematrix(1e5, 1e5, density=0.00001)
#' ncp <- abs(DelayedArray(ncp)) + 1
#' X3 <- RandomTArraySeed(c(1e5, 1e5), df=10, ncp=ncp)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomTArray-class
NULL

#' @export
#' @rdname RandomTArray-class
RandomTArraySeed <- function(dim, df, ncp, chunkdim=NULL) {
    if (missing(ncp)) {
        ncp <- NULL
    }
    new("RandomTArraySeed", dim=dim, df=df, ncp=ncp, chunkdim=chunkdim)
}

setValidity2("RandomTArraySeed", function(object) {
    if (!is.null(object@ncp)) {
        msg <- .is_valid_param(object@dim, object@ncp, "ncp")
        if (!is.null(msg)) {
            return(msg)
        }
    }
    TRUE
})

#' @export
setMethod("sampleDistrParam", "RandomTArraySeed", function(x) "df")

#' @export
setMethod("sampleDistrFun", "RandomTArraySeed", function(x) stats::qt)

#' @export
setMethod("extract_array", "RandomTArraySeed", .ncp_extract_array)

#' @export
setMethod("matrixClass", "RandomTArray", function(x) "RandomTMatrix")

#' @export
#' @rdname RandomTArray-class
setMethod("DelayedArray", "RandomTArraySeed", function(seed) new_DelayedArray(seed, Class="RandomTArray"))

#' @export
#' @rdname RandomTArray-class
RandomTArray <- function(dim, df, ncp, chunkdim=NULL) {
    DelayedArray(RandomTArraySeed(dim, df=df, ncp=ncp, chunkdim=chunkdim))
}

#' DelayedArray of random F-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of F-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param df1,df2,ncp Numeric vector used as the argument of the same name in \code{\link{qf}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#'
#' If \code{ncp} is missing, a central F distribution is assumed.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomFArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomFArray object,
#' containing random draws from a exponential distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomFArray-class
#' RandomFArraySeed-class
#' RandomFMatrix-class
#' sampleDistrParam,RandomFArraySeed-method
#' sampleDistrFun,RandomFArraySeed-method
#' matrixClass,RandomFArray-method
#' extract_array,RandomFArraySeed-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomFArraySeed(c(1e5, 1e5), df1=1, df2=10)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomFArraySeed(c(1e5, 1e5), df1=runif(1e5)*10, df2=10)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' ncp <- rsparsematrix(1e5, 1e5, density=0.00001)
#' ncp <- abs(DelayedArray(ncp)) + 1
#' X3 <- RandomFArraySeed(c(1e5, 1e5), df1=1, df2=10, ncp=ncp)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomFArray-class
NULL

#' @export
#' @rdname RandomFArray-class
RandomFArraySeed <- function(dim, df1, df2, ncp, chunkdim=NULL) {
    if (missing(ncp)) {
        ncp <- NULL
    }
    new("RandomFArraySeed", dim=dim, df1=df1, df2=df2, ncp=ncp, chunkdim=chunkdim)
}

setValidity2("RandomFArraySeed", function(object) {
    if (!is.null(object@ncp)) {
        msg <- .is_valid_param(object@dim, object@ncp, "ncp")
        if (!is.null(msg)) {
            return(msg)
        }
    }
    TRUE
})

#' @export
setMethod("sampleDistrParam", "RandomFArraySeed", function(x) c("df1", "df2"))

#' @export
setMethod("sampleDistrFun", "RandomFArraySeed", function(x) stats::qf)

#' @export
setMethod("extract_array", "RandomFArraySeed", .ncp_extract_array)

#' @export
setMethod("matrixClass", "RandomFArray", function(x) "RandomFMatrix")

#' @export
#' @rdname RandomFArray-class
setMethod("DelayedArray", "RandomFArraySeed", function(seed) new_DelayedArray(seed, Class="RandomFArray"))

#' @export
#' @rdname RandomFArray-class
RandomFArray <- function(dim, df1, df2, ncp, chunkdim=NULL) {
    DelayedArray(RandomFArraySeed(dim, df1=df1, df2=df2, ncp=ncp, chunkdim=chunkdim))
}

#' DelayedArray of random normal values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of normally distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param mean,sd Numeric vector used as \code{mean} and \code{sd}, respectively, in \code{\link{qnorm}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomNormArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomNormArray object,
#' containing random draws from a normal distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomNormArray-class
#' RandomNormArraySeed-class
#' RandomNormMatrix-class
#' sampleDistrParam,RandomNormArraySeed-method
#' sampleDistrFun,RandomNormArraySeed-method
#' matrixClass,RandomNormArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomNormArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomNormArraySeed(c(1e5, 1e5), mean=runif(1e5), sd=runif(1e5))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' mean <- rsparsematrix(1e5, 1e5, density=0.00001)
#' X3 <- RandomNormArraySeed(c(1e5, 1e5), mean=mean)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomNormArray-class
NULL

#' @export
#' @rdname RandomNormArray-class
RandomNormArraySeed <- function(dim, mean=0, sd=1, chunkdim=NULL) {
    new("RandomNormArraySeed", dim=dim, mean=mean, sd=sd, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomNormArraySeed", function(x) c("mean", "sd"))

#' @export
setMethod("sampleDistrFun", "RandomNormArraySeed", function(x) stats::qnorm)

#' @export
setMethod("matrixClass", "RandomNormArray", function(x) "RandomNormMatrix")

#' @export
#' @rdname RandomNormArray-class
setMethod("DelayedArray", "RandomNormArraySeed", function(seed) new_DelayedArray(seed, Class="RandomNormArray"))

#' @export
#' @rdname RandomNormArray-class
RandomNormArray <- function(dim, mean=0, sd=1, chunkdim=NULL) {
    DelayedArray(RandomNormArraySeed(dim, mean, sd, chunkdim=chunkdim))
}

.is_valid_param <- function(dim, param, name) {
    if (!is.null(dim(param))) {
        if (!identical(dim, dim(param))) {
            return(sprintf("'dim' and 'dim(%s)' must be the same", name))
        }
    } else if (prod(dim) %% length(param) !=0) {
        warning(sprintf("number of entries in the array is not a multiple of 'length(%s)'", name))
    }
    NULL
}

.is_valid_chunkdim <- function(dim, chunkdim) {
    if (any(chunkdim < 0)) {
        return("'chunkdim' should contain non-negative integers")
    }
    if (length(dim)!=length(chunkdim)) {
        return("'dim' and 'chunkdim' should be of the same length")
    }
    if (any(chunkdim==0 & dim > 0)) {
        return("'chunkdim' should contain positive integers for non-zero-length 'dim'")
    }
    if (any(chunkdim > dim)) {
        return("'chunkdim' should not contain values larger than 'dim'")
    }
    NULL
}

.compute_nchunks <- function(dim, chunkdim) {
    if (any(dim <= 0)) {
        0L
    } else {
        as.integer(prod(ceiling(dim/chunkdim)))
    }
}

.obtain_unique_sorted_index <- function(index) {
    coerced <- logical(length(index))
    for (i in seq_along(index)) {
        current <- index[[i]]
        if (!is.null(current) && (is.unsorted(current) || anyDuplicated(current))) {
            index[[i]] <- unique(sort(current))
            coerced[i] <- TRUE
        }
    }
    list(index=index, coerced=coerced)
}

.remap_to_original_index <- function(arr, index, reindex) {
    if (any(reindex$coerced)) {
        mapping <- vector("list", length(index))
        for (i in seq_along(mapping)) {
            if (reindex$coerced[i]) {
                mapping[[i]] <- match(index[[i]], reindex$index[[i]])
            } else {
                mapping[[i]] <- substitute()
            }
        }
        arr <- do.call("[", c(list(arr), mapping, list(drop=FALSE)))
    }
    arr
}

.extract_parameter <- function(param, index, dims) {
    if (!is.null(dim(param))) {
        extract_array(param, index)
    } else if (length(param)==1L) {
        param
    } else {
        recycle_vector(param, dims, index)
    }
}

.sample_distribution <- function(probs, FUN, params) {
    probs[] <- do.call(FUN, c(list(p=as.numeric(probs)), lapply(params, as.numeric)))
    probs
}

#' DelayedArray of random Poisson values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Poisson-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomPoisArraySeed object.
#' @param lambda Numeric vector used as \code{lambda} in \code{\link{qpois}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomPoisArray object,
#' containing random draws from a Poisson distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomPoisArray-class
#' RandomPoisArraySeed-class
#' RandomPoisMatrix-class
#' sampleDistrParam,RandomPoisArraySeed-method
#' sampleDistrFun,RandomPoisArraySeed-method
#' matrixClass,RandomPoisArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomPoisArraySeed(c(1e5, 1e5), lambda=2)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomPoisArraySeed(c(1e5, 1e5), lambda=runif(1e5), sparse=TRUE)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' lambda <- rsparsematrix(1e5, 1e5, density=0.00001)
#' lambda <- abs(DelayedArray(lambda)) + 0.1
#' X3 <- RandomPoisArraySeed(c(1e5, 1e5), lambda=lambda)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomPoisArray-class
NULL

#' @export
#' @rdname RandomPoisArray-class
RandomPoisArraySeed <- function(dim, lambda, chunkdim=NULL, sparse=FALSE) {
    new("RandomPoisArraySeed", dim=dim, lambda=lambda, chunkdim=chunkdim, sparse=sparse)
}

#' @export
setMethod("sampleDistrParam", "RandomPoisArraySeed", function(x) c("lambda"))

#' @export
setMethod("sampleDistrFun", "RandomPoisArraySeed", function(x) stats::qpois)

#' @export
setMethod("matrixClass", "RandomPoisArray", function(x) "RandomPoisMatrix")

#' @export
#' @rdname RandomPoisArray-class
setMethod("DelayedArray", "RandomPoisArraySeed", function(seed) new_DelayedArray(seed, Class="RandomPoisArray"))

#' @export
#' @rdname RandomPoisArray-class
RandomPoisArray <- function(dim, lambda, chunkdim=NULL, sparse=FALSE) {
    DelayedArray(RandomPoisArraySeed(dim, lambda, chunkdim=chunkdim, sparse=sparse))
}

#' DelayedArray of random log-normal values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of log-normally distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param meanlog,sdlog Numeric vector used as the argument of the same name in \code{\link{qlnorm}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomLnormArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomLnormArray object,
#' containing random draws from a log-normal distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomLnormArray-class
#' RandomLnormArraySeed-class
#' RandomLnormMatrix-class
#' sampleDistrParam,RandomLnormArraySeed-method
#' sampleDistrFun,RandomLnormArraySeed-method
#' matrixClass,RandomLnormArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomLnormArraySeed(c(1e5, 1e5))
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomLnormArraySeed(c(1e5, 1e5), meanlog=runif(1e5), sdlog=runif(1e5))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' meanlog <- rsparsematrix(1e5, 1e5, density=0.00001)
#' X3 <- RandomLnormArraySeed(c(1e5, 1e5), meanlog=meanlog)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomLnormArray-class
NULL

#' @export
#' @rdname RandomLnormArray-class
RandomLnormArraySeed <- function(dim, meanlog=0, sdlog=1, chunkdim=NULL) {
    new("RandomLnormArraySeed", dim=dim, meanlog=meanlog, sdlog=sdlog, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomLnormArraySeed", function(x) c("meanlog", "sdlog"))

#' @export
setMethod("sampleDistrFun", "RandomLnormArraySeed", function(x) stats::qlnorm)

#' @export
setMethod("matrixClass", "RandomLnormArray", function(x) "RandomLnormMatrix")

#' @export
#' @rdname RandomLnormArray-class
setMethod("DelayedArray", "RandomLnormArraySeed", function(seed) new_DelayedArray(seed, Class="RandomLnormArray"))

#' @export
#' @rdname RandomLnormArray-class
RandomLnormArray <- function(dim, meanlog=0, sdlog=1, chunkdim=NULL) {
    DelayedArray(RandomLnormArraySeed(dim, meanlog, sdlog, chunkdim=chunkdim))
}

#' DelayedArray of random geometric-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of geometric-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomGeomArraySeed object.
#' @param prob Numeric vector used as \code{prob} in \code{\link{qgeom}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomGeomArray object,
#' containing random draws from a geometric distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomGeomArray-class
#' RandomGeomArraySeed-class
#' RandomGeomMatrix-class
#' sampleDistrParam,RandomGeomArraySeed-method
#' sampleDistrFun,RandomGeomArraySeed-method
#' matrixClass,RandomGeomArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomGeomArraySeed(c(1e5, 1e5), prob=0.5)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomGeomArraySeed(c(1e5, 1e5), prob=runif(1e5, 0, 0.1), sparse=TRUE)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' prob <- RandomUnifArray(c(1e5, 1e5))
#' X3 <- RandomGeomArraySeed(c(1e5, 1e5), prob=prob)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomGeomArray-class
NULL

#' @export
#' @rdname RandomGeomArray-class
RandomGeomArraySeed <- function(dim, prob, chunkdim=NULL, sparse=FALSE) {
    new("RandomGeomArraySeed", dim=dim, prob=prob, chunkdim=chunkdim, sparse=sparse)
}

#' @export
setMethod("sampleDistrParam", "RandomGeomArraySeed", function(x) "prob")

#' @export
setMethod("sampleDistrFun", "RandomGeomArraySeed", function(x) stats::qgeom)

#' @export
setMethod("matrixClass", "RandomGeomArray", function(x) "RandomGeomMatrix")

#' @export
#' @rdname RandomGeomArray-class
setMethod("DelayedArray", "RandomGeomArraySeed", function(seed) new_DelayedArray(seed, Class="RandomGeomArray"))

#' @export
#' @rdname RandomGeomArray-class
RandomGeomArray <- function(dim, prob, chunkdim=NULL, sparse=FALSE) {
    DelayedArray(RandomGeomArraySeed(dim, prob=prob, chunkdim=chunkdim, sparse=sparse))
}

#' @export
#' @import SparseArray
#' @import DelayedArray
setClass("RandomArraySeed", contains="VIRTUAL", slots=c(dim="integer", chunkdim="integer", seeds="list", sparse="logical"))


#' @export
setClass("RandomUnifArraySeed", contains="RandomArraySeed", slots=c(min="ANY", max="ANY"))

#' @export
setClass("RandomUnifArray", contains="DelayedArray", representation(seed="RandomUnifArraySeed"))

#' @export
setClass("RandomUnifMatrix", contains="DelayedMatrix", representation(seed="RandomUnifArraySeed"))


#' @export
setClass("RandomNormArraySeed", contains="RandomArraySeed", slots=c(mean="ANY", sd="ANY"))

#' @export
setClass("RandomNormArray", contains="DelayedArray", representation(seed="RandomNormArraySeed"))

#' @export
setClass("RandomNormMatrix", contains="DelayedMatrix", representation(seed="RandomNormArraySeed"))


#' @export
setClass("RandomPoisArraySeed", contains="RandomArraySeed", slots=c(lambda="ANY"))

#' @export
setClass("RandomPoisArray", contains="DelayedArray", representation(seed="RandomPoisArraySeed"))

#' @export
setClass("RandomPoisMatrix", contains="DelayedMatrix", representation(seed="RandomPoisArraySeed"))


#' @export
setClass("RandomExpArraySeed", contains="RandomArraySeed", slots=c(rate="ANY"))

#' @export
setClass("RandomExpArray", contains="DelayedArray", representation(seed="RandomExpArraySeed"))

#' @export
setClass("RandomExpMatrix", contains="DelayedMatrix", representation(seed="RandomExpArraySeed"))


#' @export
setClass("RandomBetaArraySeed", contains="RandomArraySeed", slots=c(shape1="ANY", shape2="ANY", ncp="ANY"))

#' @export
setClass("RandomBetaArray", contains="DelayedArray", representation(seed="RandomBetaArraySeed"))

#' @export
setClass("RandomBetaMatrix", contains="DelayedMatrix", representation(seed="RandomBetaArraySeed"))


#' @export
setClass("RandomBinomArraySeed", contains="RandomArraySeed", slots=c(size="ANY", prob="ANY"))

#' @export
setClass("RandomBinomArray", contains="DelayedArray", representation(seed="RandomBinomArraySeed"))

#' @export
setClass("RandomBinomMatrix", contains="DelayedMatrix", representation(seed="RandomBinomArraySeed"))


#' @export
setClass("RandomCauchyArraySeed", contains="RandomArraySeed", slots=c(location="ANY", scale="ANY"))

#' @export
setClass("RandomCauchyArray", contains="DelayedArray", representation(seed="RandomCauchyArraySeed"))

#' @export
setClass("RandomCauchyMatrix", contains="DelayedMatrix", representation(seed="RandomCauchyArraySeed"))


#' @export
setClass("RandomChisqArraySeed", contains="RandomArraySeed", slots=c(df="ANY", ncp="ANY"))

#' @export
setClass("RandomChisqArray", contains="DelayedArray", representation(seed="RandomChisqArraySeed"))

#' @export
setClass("RandomChisqMatrix", contains="DelayedMatrix", representation(seed="RandomChisqArraySeed"))


#' @export
setClass("RandomFArraySeed", contains="RandomArraySeed", slots=c(df1="ANY", df2="ANY", ncp="ANY"))

#' @export
setClass("RandomFArray", contains="DelayedArray", representation(seed="RandomFArraySeed"))

#' @export
setClass("RandomFMatrix", contains="DelayedMatrix", representation(seed="RandomFArraySeed"))


#' @export
setClass("RandomGammaArraySeed", contains="RandomArraySeed", slots=c(shape="ANY", scale="ANY"))

#' @export
setClass("RandomGammaArray", contains="DelayedArray", representation(seed="RandomGammaArraySeed"))

#' @export
setClass("RandomGammaMatrix", contains="DelayedMatrix", representation(seed="RandomGammaArraySeed"))


#' @export
setClass("RandomNbinomArraySeed", contains="RandomArraySeed", slots=c(prob="ANY", size="ANY", mu="ANY"))

#' @export
setClass("RandomNbinomArray", contains="DelayedArray", representation(seed="RandomNbinomArraySeed"))

#' @export
setClass("RandomNbinomMatrix", contains="DelayedMatrix", representation(seed="RandomNbinomArraySeed"))


#' @export
setClass("RandomGeomArraySeed", contains="RandomArraySeed", slots=c(prob="ANY"))

#' @export
setClass("RandomGeomArray", contains="DelayedArray", representation(seed="RandomGeomArraySeed"))

#' @export
setClass("RandomGeomMatrix", contains="DelayedMatrix", representation(seed="RandomGeomArraySeed"))


#' @export
setClass("RandomHyperArraySeed", contains="RandomArraySeed", slots=c(m="ANY", n="ANY", k="ANY"))

#' @export
setClass("RandomHyperArray", contains="DelayedArray", representation(seed="RandomHyperArraySeed"))

#' @export
setClass("RandomHyperMatrix", contains="DelayedMatrix", representation(seed="RandomHyperArraySeed"))


#' @export
setClass("RandomLnormArraySeed", contains="RandomArraySeed", slots=c(meanlog="ANY", sdlog="ANY"))

#' @export
setClass("RandomLnormArray", contains="DelayedArray", representation(seed="RandomLnormArraySeed"))

#' @export
setClass("RandomLnormMatrix", contains="DelayedMatrix", representation(seed="RandomLnormArraySeed"))


#' @export
setClass("RandomLogisArraySeed", contains="RandomArraySeed", slots=c(location="ANY", scale="ANY"))

#' @export
setClass("RandomLogisArray", contains="DelayedArray", representation(seed="RandomLogisArraySeed"))

#' @export
setClass("RandomLogisMatrix", contains="DelayedMatrix", representation(seed="RandomLogisArraySeed"))


#' @export
setClass("RandomTArraySeed", contains="RandomArraySeed", slots=c(df="ANY", ncp="ANY"))

#' @export
setClass("RandomTArray", contains="DelayedArray", representation(seed="RandomTArraySeed"))

#' @export
setClass("RandomTMatrix", contains="DelayedMatrix", representation(seed="RandomTArraySeed"))


#' @export
setClass("RandomWilcoxArraySeed", contains="RandomArraySeed", slots=c(m="ANY", n="ANY"))

#' @export
setClass("RandomWilcoxArray", contains="DelayedArray", representation(seed="RandomWilcoxArraySeed"))

#' @export
setClass("RandomWilcoxMatrix", contains="DelayedMatrix", representation(seed="RandomWilcoxArraySeed"))


#' @export
setClass("RandomWeibullArraySeed", contains="RandomArraySeed", slots=c(shape="ANY", scale="ANY"))

#' @export
setClass("RandomWeibullArray", contains="DelayedArray", representation(seed="RandomWeibullArraySeed"))

#' @export
setClass("RandomWeibullMatrix", contains="DelayedMatrix", representation(seed="RandomWeibullArraySeed"))

#' DelayedArray of random chi-squared-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of chi-squared-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param df,ncp Numeric vector used as the argument of the same name in \code{\link{qchisq}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomChisqArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomChisqArray object,
#' containing random draws from a chi-squared distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomChisqArray-class
#' RandomChisqArraySeed-class
#' RandomChisqMatrix-class
#' sampleDistrParam,RandomChisqArraySeed-method
#' sampleDistrFun,RandomChisqArraySeed-method
#' matrixClass,RandomChisqArray-method
#' extract_array,RandomChisqArraySeed-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomChisqArraySeed(c(1e5, 1e5), df=5)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomChisqArraySeed(c(1e5, 1e5), df=runif(1e5)*20)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' df <- rsparsematrix(1e5, 1e5, density=0.00001)
#' df <- abs(DelayedArray(df) + 1) * 10
#' X3 <- RandomChisqArraySeed(c(1e5, 1e5), df=df)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomChisqArray-class
NULL

#' @export
#' @rdname RandomChisqArray-class
RandomChisqArraySeed <- function(dim, df, ncp=0, chunkdim=NULL) {
    if (missing(ncp)) {
        ncp <- NULL
    }
    new("RandomChisqArraySeed", dim=dim, df=df, ncp=ncp, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomChisqArraySeed", function(x) "df")

#' @export
setMethod("sampleDistrFun", "RandomChisqArraySeed", function(x) stats::qchisq)

#' @export
setMethod("extract_array", "RandomChisqArraySeed", .ncp_extract_array)

#' @export
setMethod("matrixClass", "RandomChisqArray", function(x) "RandomChisqMatrix")

#' @export
#' @rdname RandomChisqArray-class
setMethod("DelayedArray", "RandomChisqArraySeed", function(seed) new_DelayedArray(seed, Class="RandomChisqArray"))

#' @export
#' @rdname RandomChisqArray-class
RandomChisqArray <- function(dim, df, ncp=0, chunkdim=NULL) {
    if (missing(ncp)) {
        # Preserve missingness.
        DelayedArray(RandomChisqArraySeed(dim, df=df, chunkdim=chunkdim))
    } else {
        DelayedArray(RandomChisqArraySeed(dim, df=df, ncp=ncp, chunkdim=chunkdim))
    }
}

#' DelayedArray of random beta-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of beta-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param shape1,shape2,ncp Numeric vector used as the argument of the same name in \code{\link{qbeta}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomBetaArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomBetaArray object,
#' containing random draws from a beta distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomBetaArray-class
#' RandomBetaArraySeed-class
#' RandomBetaMatrix-class
#' sampleDistrParam,RandomBetaArraySeed-method
#' sampleDistrFun,RandomBetaArraySeed-method
#' extract_array,RandomBetaArraySeed-method
#' matrixClass,RandomBetaArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomBetaArraySeed(c(1e5, 1e5), shape1=1, shape2=10)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomBetaArraySeed(c(1e5, 1e5), shape1=runif(1e5), shape2=2)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' s1 <- rsparsematrix(1e5, 1e5, density=0.00001)
#' s1 <- abs(DelayedArray(s1)) + 1
#' X3 <- RandomBetaArraySeed(c(1e5, 1e5), shape1=s1, shape2=s1+1)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomBetaArray-class
NULL

#' @export
#' @rdname RandomBetaArray-class
RandomBetaArraySeed <- function(dim, shape1, shape2, ncp=0, chunkdim=NULL) {
    # Ensure that the corresponding internal routine in qbeta gets called if ncp is missing.
    if (missing(ncp)) {
        ncp <- NULL
    }
    new("RandomBetaArraySeed", dim=dim, shape1=shape1, shape2=shape2, ncp=ncp, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomBetaArraySeed", function(x) c("shape1", "shape2"))

#' @export
setMethod("sampleDistrFun", "RandomBetaArraySeed", function(x) stats::qbeta)

#' @export
setMethod("extract_array", "RandomBetaArraySeed", .ncp_extract_array)

#' @export
setMethod("matrixClass", "RandomBetaArray", function(x) "RandomBetaMatrix")

#' @export
#' @rdname RandomBetaArray-class
setMethod("DelayedArray", "RandomBetaArraySeed", function(seed) new_DelayedArray(seed, Class="RandomBetaArray"))

#' @export
#' @rdname RandomBetaArray-class
RandomBetaArray <- function(dim, shape1, shape2, ncp=0, chunkdim=NULL) {
    if (missing(ncp)) {
        # Preserve missingness.
        seed <- RandomBetaArraySeed(dim, shape1, shape2, chunkdim=chunkdim)
    } else {
        seed <- RandomBetaArraySeed(dim, shape1, shape2, ncp=ncp, chunkdim=chunkdim)
    }
    DelayedArray(seed)
}

#' DelayedArray of random Weibull-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Weibull-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomWeibullArraySeed object.
#' @param shape,scale Numeric vector used as the argument of the same name in \code{\link{qweibull}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' 
#' @return 
#' All constructors return an instance of a RandomWeibullArray object,
#' containing random draws from a Weibull distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomWeibullArray-class
#' RandomWeibullArraySeed-class
#' RandomWeibullMatrix-class
#' sampleDistrParam,RandomWeibullArraySeed-method
#' sampleDistrFun,RandomWeibullArraySeed-method
#' matrixClass,RandomWeibullArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomWeibullArraySeed(c(1e5, 1e5), shape=10)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomWeibullArraySeed(c(1e5, 1e5), shape=round(runif(1e5, 10, 20)))
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' shape <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
#' X3 <- RandomWeibullArraySeed(c(1e5, 1e5), shape=shape)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomWeibullArray-class
NULL

#' @export
#' @rdname RandomWeibullArray-class
RandomWeibullArraySeed <- function(dim, shape, scale=1, chunkdim=NULL) {
    new("RandomWeibullArraySeed", dim=dim, shape=shape, scale=scale, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomWeibullArraySeed", function(x) c("shape", "scale"))

#' @export
setMethod("sampleDistrFun", "RandomWeibullArraySeed", function(x) stats::qweibull)

#' @export
setMethod("matrixClass", "RandomWeibullArray", function(x) "RandomWeibullMatrix")

#' @export
#' @rdname RandomWeibullArray-class
setMethod("DelayedArray", "RandomWeibullArraySeed", function(seed) new_DelayedArray(seed, Class="RandomWeibullArray"))

#' @export
#' @rdname RandomWeibullArray-class
RandomWeibullArray <- function(dim, shape, scale=1, chunkdim=NULL) {
    DelayedArray(RandomWeibullArraySeed(dim, shape=shape, scale=scale, chunkdim=chunkdim))
}

#' DelayedArray of random hypergeometric-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of hypergeometric-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomHyperArraySeed object.
#' @param m,n,k Numeric vector used as the argument of the same name in \code{\link{qhyper}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomHyperArray object,
#' containing random draws from a hypergeometric distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomHyperArray-class
#' RandomHyperArraySeed-class
#' RandomHyperMatrix-class
#' sampleDistrParam,RandomHyperArraySeed-method
#' sampleDistrFun,RandomHyperArraySeed-method
#' matrixClass,RandomHyperArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomHyperArraySeed(c(1e5, 1e5), m=10, n=20, k=15)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomHyperArraySeed(c(1e5, 1e5), m=round(runif(1e5, 10, 20)), 
#'     n=20, k=15, sparse=TRUE)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' m <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
#' X3 <- RandomHyperArraySeed(c(1e5, 1e5), m=m, n=50, k=20)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomHyperArray-class
NULL

#' @export
#' @rdname RandomHyperArray-class
RandomHyperArraySeed <- function(dim, m, n, k, chunkdim=NULL, sparse=FALSE) {
    new("RandomHyperArraySeed", dim=dim, m=m, n=n, k=k, chunkdim=chunkdim, sparse=sparse)
}

#' @export
setMethod("sampleDistrParam", "RandomHyperArraySeed", function(x) c("m", "n", "k"))

#' @export
setMethod("sampleDistrFun", "RandomHyperArraySeed", function(x) stats::qhyper)

#' @export
setMethod("matrixClass", "RandomHyperArray", function(x) "RandomHyperMatrix")

#' @export
#' @rdname RandomHyperArray-class
setMethod("DelayedArray", "RandomHyperArraySeed", function(seed) new_DelayedArray(seed, Class="RandomHyperArray"))

#' @export
#' @rdname RandomHyperArray-class
RandomHyperArray <- function(dim, m, n, k, chunkdim=NULL, sparse=FALSE) {
    DelayedArray(RandomHyperArraySeed(dim, m=m, n=n, k=k, chunkdim=chunkdim, sparse=sparse))
}

#' DelayedArray of random gamma-distributed values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of gamma-distributed values.
#'
#' @param dim Integer vector of positive length, specifying the dimensions of the array.
#' @param shape,rate,scale Numeric vector used as the argument of the same name in \code{\link{qgamma}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#'
#' If \code{scale} is explicitly supplied, \code{rate} is ignored.
#' @param chunkdim Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.
#' @param seed A RandomGammaArraySeed object.
#' 
#' @return 
#' All constructors return an instance of a RandomGammaArray object,
#' containing random draws from a gamma distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomGammaArray-class
#' RandomGammaArraySeed-class
#' RandomGammaMatrix-class
#' sampleDistrParam,RandomGammaArraySeed-method
#' sampleDistrFun,RandomGammaArraySeed-method
#' matrixClass,RandomGammaArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomGammaArraySeed(c(1e5, 1e5), shape=1, rate=10)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomGammaArraySeed(c(1e5, 1e5), shape=runif(1e5), rate=2)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' s1 <- rsparsematrix(1e5, 1e5, density=0.00001)
#' s1 <- abs(DelayedArray(s1)) + 1
#' X3 <- RandomGammaArraySeed(c(1e5, 1e5), shape=s1, rate=s1+1)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomGammaArray-class
NULL

#' @export
#' @rdname RandomGammaArray-class
RandomGammaArraySeed <- function(dim, shape, rate=1, scale=1/rate, chunkdim=NULL) {
    # Don't bother checking if rate and scale are consistent,
    # as this takes too much effort if one or the other is a matrix.
    new("RandomGammaArraySeed", dim=dim, shape=shape, scale=scale, chunkdim=chunkdim)
}

#' @export
setMethod("sampleDistrParam", "RandomGammaArraySeed", function(x) c("shape", "scale"))

#' @export
setMethod("sampleDistrFun", "RandomGammaArraySeed", function(x) stats::qgamma)

#' @export
setMethod("matrixClass", "RandomGammaArray", function(x) "RandomGammaMatrix")

#' @export
#' @rdname RandomGammaArray-class
setMethod("DelayedArray", "RandomGammaArraySeed", function(seed) new_DelayedArray(seed, Class="RandomGammaArray"))

#' @export
#' @rdname RandomGammaArray-class
RandomGammaArray <- function(dim, shape, rate=1, scale=1/rate, chunkdim=NULL) {
    DelayedArray(RandomGammaArraySeed(dim, shape=shape, scale=scale, chunkdim=chunkdim))
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

recycle_vector <- function(vec, dim, index) {
    .Call('_DelayedRandomArray_recycle_vector', PACKAGE = 'DelayedRandomArray', vec, dim, index)
}

sample_standard_uniform <- function(dim, chunkdim, seeds, index, stream_start = 0L) {
    .Call('_DelayedRandomArray_sample_standard_uniform', PACKAGE = 'DelayedRandomArray', dim, chunkdim, seeds, index, stream_start)
}

# This tests the recycling utilities.
# library(testthat); library(DelayedRandomArray); source("test-recycle.R")

REFCYCLE <- function(vec, dim, index) {
    mat <- array(seq_len(prod(dim)), dim)
    keep <- extract_array(mat, index)
    vec[(as.integer(keep)-1) %% length(vec) + 1]
}

test_that("recycling works as expected (2D)", {
    for (i in c(10, 20, 5, 7)) {
        X <- runif(i)
        out <- DelayedRandomArray:::recycle_vector(X, c(10, 5), list(NULL, NULL))
        ref <- REFCYCLE(X, c(10, 5), list(NULL, NULL))
        expect_identical(out, ref)

        out <- DelayedRandomArray:::recycle_vector(X, c(10, 5), list(2:5, c(1,3,5)))
        ref <- REFCYCLE(X, c(10, 5), list(2:5, c(1,3,5)))
        expect_identical(out, ref)
    }
})

test_that("recycling works as expected (3D)", {
    for (i in c(10, 20, 50, 5, 7)) {
        X <- runif(i)
        out <- DelayedRandomArray:::recycle_vector(X, c(10, 5, 2), list(NULL, NULL, NULL))
        ref <- REFCYCLE(X, c(10, 5, 2), list(NULL, NULL, NULL))
        expect_identical(out, ref)

        out <- DelayedRandomArray:::recycle_vector(X, c(10, 5, 2), list(2:5, c(1,3,5), 1))
        ref <- REFCYCLE(X, c(10, 5, 2), list(2:5, c(1,3,5), 1))
        expect_identical(out, ref)

        out <- DelayedRandomArray:::recycle_vector(X, c(10, 5, 2), list(2:5, c(1,3,5), 1:2))
        ref <- REFCYCLE(X, c(10, 5, 2), list(2:5, c(1,3,5), 1:2))
        expect_identical(out, ref)
    }
})

test_that("recycling works as expected (1D)", {
    for (i in c(10, 20, 5, 7)) {
        X <- runif(i)
        out <- DelayedRandomArray:::recycle_vector(X, 100, list(NULL, NULL))
        ref <- REFCYCLE(X, 100, list(NULL))
        expect_identical(out, ref)

        out <- DelayedRandomArray:::recycle_vector(X, c(100), list(1:10*10))
        ref <- REFCYCLE(X, c(100), list(1:10*10))
        expect_identical(out, ref)
    }
})

# This checks that the chunked sampling is self-consistent.
# library(DelayedRandomArray); library(testthat); source("test-chunking.R")

test_that("recovery of a single chunk makes sense", {
    seeds <- list(c(12345L, 12345L))
    arr <- DelayedRandomArray:::sample_standard_uniform(c(10, 10), c(10, 10), seeds, list(1:10, 1:10))

    # Looks pretty random to me:
    expect_identical(dim(arr), c(10L, 10L))
    expect_false(any(arr==0 | arr==1))
    expect_true(is.unsorted(as.vector(arr)))
    expect_identical(anyDuplicated(arr), 0L)

    # Reproducible:
    arr2 <- DelayedRandomArray:::sample_standard_uniform(c(10, 10), c(10, 10), seeds, list(1:10, 1:10))
    expect_identical(arr2, arr)

    arr2 <- DelayedRandomArray:::sample_standard_uniform(c(10, 10), c(10, 10), seeds, list(NULL, NULL))
    expect_identical(arr2, arr)

    # Works with different chunk sizes:
    arr3 <- DelayedRandomArray:::sample_standard_uniform(c(10, 5), c(10, 5), seeds, list(1:10, 1:5))
    expect_identical(arr[,1:5], arr3)
    
    arr3 <- DelayedRandomArray:::sample_standard_uniform(c(10, 5), c(10, 5), seeds, list(NULL, NULL))
    expect_identical(arr[,1:5], arr3)

    # Works with arrays.
    arr4 <- DelayedRandomArray:::sample_standard_uniform(c(10, 5, 2), c(10, 5, 2), seeds, list(1:10, 1:5, 1:2))
    expect_identical(dim(arr4), c(10L, 5L, 2L))

    arr4 <- DelayedRandomArray:::sample_standard_uniform(c(10, 5, 2), c(10, 5, 2), seeds, list(NULL, NULL, NULL))
    expect_identical(dim(arr4), c(10L, 5L, 2L))
    expect_identical(arr4[,,1], arr3)

    subarr <- arr4[,,2]
    expect_false(any(subarr==0 | subarr==1))
    expect_true(is.unsorted(as.vector(subarr)))
    expect_identical(anyDuplicated(subarr), 0L)
})

FULL_COMPARE <- function(dim, chunkdim) {
    nchunks <- ceiling(dim/chunkdim)
    seeds <- dqrng::generateSeedVectors(prod(nchunks))
    full <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, lapply(dim, seq_len))
    expect_identical(dim(full), as.integer(dim))

    identifier <- c(1, cumprod(head(nchunks, -1)))
    for (i in seq_along(seeds)) {
        chunk.dex <- integer(length(dim))
        curid <- (i-1)
        for (j in rev(seq_along(dim))) {
            chunk.dex[j] <- as.integer(curid / identifier[j])
            curid <- curid %% identifier[j]
        }

        everything <- subsets <- list()
        for (j in seq_along(dim)) {
            idx <- seq_len(chunkdim[j])
            full.idx <- idx + chunk.dex[j] * chunkdim[j]
            keep <- full.idx <= dim[j]
            subsets[[j]] <- full.idx[keep]
            everything[[j]] <- idx[keep]
        }

        current.chunk <- DelayedRandomArray:::sample_standard_uniform(chunkdim, chunkdim, seeds[i], everything, stream_start = i-1)
        extracted <- do.call("[", c(list(full), subsets, list(drop=FALSE)))
        expect_identical(extracted, current.chunk)

        # Same result with NULL indices.
        current.chunk <- DelayedRandomArray:::sample_standard_uniform(chunkdim, chunkdim, seeds[i], everything, stream_start = i-1)
        extracted <- do.call("[", c(list(full), subsets, list(drop=FALSE)))
        expect_identical(extracted, current.chunk)

        full <- do.call("[<-", c(list(full), subsets, list(value=0)))
    }

    expect_true(all(full==0))
}

test_that("full extraction works with multiple chunks in a grid", {
    # 2D cases.
    FULL_COMPARE(c(100, 50), c(20, 10))
    FULL_COMPARE(c(100, 50), c(20, 25))
    FULL_COMPARE(c(50, 100), c(20, 25))
    FULL_COMPARE(c(100, 50), c(9, 8))

    # 3D cases.
    FULL_COMPARE(c(100, 50, 20), c(20, 10, 5))
    FULL_COMPARE(c(100, 50, 20), c(20, 25, 2))
    FULL_COMPARE(c(100, 50, 20), c(9, 8, 7))
    FULL_COMPARE(c(50, 100, 20), c(9, 8, 7))

    # 1D cases.
    FULL_COMPARE(c(100), c(20))
    FULL_COMPARE(c(100), c(9))
})

test_that("extraction of a subarray works as expected", {
    # In the 2D case.
    dim <- c(100, 50)
    chunkdim <- c(24, 8)
    nseeds <- prod(ceiling(dim/chunkdim))
    seeds <- dqrng::generateSeedVectors(nseeds)
    full <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, list(NULL, NULL))

    for (indices in list(
        list(2:30, NULL),
        list(NULL, 2:30),
        list(5:50, 2:30),
        list(2:5*10, NULL),
        list(NULL, 2:5*10),
        list(c(1,10,51,99), NULL),
        list(NULL, c(1,10,49)),
        list(20:40*2, 10:20*2)
    )) {
        sub <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, indices)
        alt <- extract_array(full, indices)
        expect_identical(sub, alt)
    }

    # In the 3D case.
    dim <- c(100, 50, 80)
    chunkdim <- c(30, 10, 15)
    nseeds <- prod(ceiling(dim/chunkdim))
    seeds <- dqrng::generateSeedVectors(nseeds)
    full <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, list(NULL, NULL, NULL))

    for (indices in list(
        list(2:30, NULL, NULL),
        list(NULL, 2:30, NULL),
        list(5:50, NULL, 2:30),
        list(NULL, 2:5*10, NULL),
        list(NULL, NULL, 2:5*10),
        list(2:50, c(1,10,49), NULL),
        list(2:50, NULL, c(1,10,49)),
        list(20:40*2, 10:20*2, 3:50)
    )) {
        sub <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, indices)
        alt <- extract_array(full, indices)
        expect_identical(sub, alt)
    }

    # In the 1D case.
    dim <- c(100)
    chunkdim <- c(8)
    nseeds <- prod(ceiling(dim/chunkdim))
    seeds <- dqrng::generateSeedVectors(nseeds)
    full <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, list(NULL))

    for (indices in list(
        list(2:30),
        list(c(1,10,49)),
        list(20:40*2)
    )) {
        sub <- DelayedRandomArray:::sample_standard_uniform(dim, chunkdim, seeds, indices)
        alt <- extract_array(full, indices)
        expect_identical(sub, alt)
    }
})

test_that("handles edge cases", {
    full <- DelayedRandomArray:::sample_standard_uniform(c(0, 0, 1), c(0, 0, 1), list(), list(NULL, NULL, NULL))
    expect_identical(dim(full), c(0L, 0L, 1L))

    full <- DelayedRandomArray:::sample_standard_uniform(c(20, 0, 1), c(20, 0, 1), list(), list(NULL, NULL, NULL))
    expect_identical(dim(full), c(20L, 0L, 1L))
})

#' DelayedArray of random binomial values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of binomial-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomBinomArraySeed object.
#' @param size,prob Numeric vector used as the argument of the same name in \code{\link{qbinom}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomBinomArray object,
#' containing random draws from a binomial distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomBinomArray-class
#' RandomBinomArraySeed-class
#' RandomBinomMatrix-class
#' sampleDistrParam,RandomBinomArraySeed-method
#' sampleDistrFun,RandomBinomArraySeed-method
#' matrixClass,RandomBinomArray-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomBinomArraySeed(c(1e5, 1e5), size=10, prob=0.5)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomBinomArraySeed(c(1e5, 1e5), size=10, 
#'     prob=runif(1e5, 0, 0.1), sparse=TRUE)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' size <- rsparsematrix(1e5, 1e5, density=0.00001)
#' size <- round(abs(DelayedArray(size)) * 10)
#' X3 <- RandomBinomArraySeed(c(1e5, 1e5), size=size, prob=0.5)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomBinomArray-class
NULL

#' @export
#' @rdname RandomBinomArray-class
RandomBinomArraySeed <- function(dim, size, prob, chunkdim=NULL, sparse=FALSE) {
    new("RandomBinomArraySeed", dim=dim, size=size, prob=prob, chunkdim=chunkdim, sparse=sparse)
}

#' @export
setMethod("sampleDistrParam", "RandomBinomArraySeed", function(x) c("size", "prob"))

#' @export
setMethod("sampleDistrFun", "RandomBinomArraySeed", function(x) stats::qbinom)

#' @export
setMethod("matrixClass", "RandomBinomArray", function(x) "RandomBinomMatrix")

#' @export
#' @rdname RandomBinomArray-class
setMethod("DelayedArray", "RandomBinomArraySeed", function(seed) new_DelayedArray(seed, Class="RandomBinomArray"))

#' @export
#' @rdname RandomBinomArray-class
RandomBinomArray <- function(dim, size, prob, chunkdim=NULL, sparse=FALSE) {
    DelayedArray(RandomBinomArraySeed(dim, size, prob, chunkdim=chunkdim, sparse=sparse))
}

#' DelayedArray of random negative binomial values
#'
#' A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of negative binomial-distributed values.
#'
#' @inheritParams RandomUnifArray
#' @param seed A RandomNbinomArraySeed object.
#' @param prob,size,mu Numeric vector used as the argument of the same name in \code{\link{qnbinom}}.
#' Alternatively, a numeric array-like object with the same dimensions as \code{dim}.
#'
#' Exactly one of \code{prob} or \code{mu} should be supplied.
#' @param sparse Logical scalar indicating whether the sampled array should be treated as sparse. 
#' 
#' @return 
#' All constructors return an instance of a RandomNbinomArray object,
#' containing random draws from a negative binomial distribution with the specified parameters.
#'
#' @author Aaron Lun
#' 
#' @aliases
#' RandomNbinomArray-class
#' RandomNbinomArraySeed-class
#' RandomNbinomMatrix-class
#' sampleDistrParam,RandomNbinomArraySeed-method
#' sampleDistrFun,RandomNbinomArraySeed-method
#' matrixClass,RandomNbinomArray-method
#' extract_array,RandomNbinomArraySeed-method
#'
#' @seealso
#' The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
#' 
#' @examples
#' X <- RandomNbinomArraySeed(c(1e5, 1e5), size=10, mu=20)
#' Y <- DelayedArray(X)
#' Y
#'
#' # Fiddling with the distribution parameters:
#' X2 <- RandomNbinomArraySeed(c(1e5, 1e5), size=10, mu=runif(1e5), sparse=TRUE)
#' Y2 <- DelayedArray(X2)
#' Y2
#'
#' # Using another array as input:
#' library(Matrix)
#' lambda <- rsparsematrix(1e5, 1e5, density=0.00001)
#' lambda <- abs(DelayedArray(lambda)) + 0.1
#' X3 <- RandomNbinomArraySeed(c(1e5, 1e5), size=1, mu=lambda)
#' Y3 <- DelayedArray(X3)
#' Y3
#' 
#' @docType class
#' @name RandomNbinomArray-class
NULL

#' @export
#' @rdname RandomNbinomArray-class
RandomNbinomArraySeed <- function(dim, prob=prob, size=size, mu=mu, chunkdim=NULL, sparse=FALSE) {
    if (missing(prob)) {
        prob <- NULL
    }
    if (missing(mu)) {
        mu <- NULL
    }
    new("RandomNbinomArraySeed", dim=dim, prob=prob, size=size, mu=mu, chunkdim=chunkdim, sparse=sparse)
}

setValidity2("RandomNbinomArraySeed", function(object) {
    if (is.null(object@prob) == is.null(object@mu)) {
        return("exactly one of 'mu' or 'prob' should be supplied")
    }

    if (!is.null(object@prob)) {
        msg <- .is_valid_param(object@dim, object@prob, "prob")
        if (!is.null(msg)) {
            return(msg)
        }
    }

    if (!is.null(object@mu)) {
        msg <- .is_valid_param(object@dim, object@mu, "mu")
        if (!is.null(msg)) {
            return(msg)
        }
    }
    TRUE
})

#' @export
setMethod("sampleDistrParam", "RandomNbinomArraySeed", function(x) "size")

#' @export
setMethod("sampleDistrFun", "RandomNbinomArraySeed", function(x) stats::qnbinom)

#' @export
setMethod("extract_array", "RandomNbinomArraySeed", function(x, index) {
    reindex <- .obtain_unique_sorted_index(index)
    arr <- sample_standard_uniform(dim(x), x@chunkdim, x@seeds, reindex$index)

    params <- lapply(sampleDistrParam(x), function(i) .extract_parameter(slot(x, i), reindex$index, dim(x)))
    if (!is.null(x@prob)) {
        params$prob <- .extract_parameter(x@prob, reindex$index, dim(x))
    }
    if (!is.null(x@mu)) {
        params$mu <- .extract_parameter(x@mu, reindex$index, dim(x))
    }

    arr <- .sample_distribution(arr, sampleDistrFun(x), params)
    .remap_to_original_index(arr, index, reindex)
})

#' @export
setMethod("matrixClass", "RandomNbinomArray", function(x) "RandomNbinomMatrix")

#' @export
#' @rdname RandomNbinomArray-class
setMethod("DelayedArray", "RandomNbinomArraySeed", function(seed) new_DelayedArray(seed, Class="RandomNbinomArray"))

#' @export
#' @rdname RandomNbinomArray-class
RandomNbinomArray <- function(dim, prob, size, mu, chunkdim=NULL, sparse=FALSE) {
    DelayedArray(RandomNbinomArraySeed(dim, prob=prob, size=size, mu=mu, chunkdim=chunkdim, sparse=sparse))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomLogisArray-class.R
\docType{class}
\name{RandomLogisArray-class}
\alias{RandomLogisArray-class}
\alias{RandomLogisArraySeed-class}
\alias{RandomLogisMatrix-class}
\alias{sampleDistrParam,RandomLogisArraySeed-method}
\alias{sampleDistrFun,RandomLogisArraySeed-method}
\alias{matrixClass,RandomLogisArray-method}
\alias{RandomLogisArraySeed}
\alias{DelayedArray,RandomLogisArraySeed-method}
\alias{RandomLogisArray}
\title{DelayedArray of random log-normal values}
\usage{
RandomLogisArraySeed(dim, location = 0, scale = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomLogisArraySeed}(seed)

RandomLogisArray(dim, location = 0, scale = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{location, scale}{Numeric vector used as the argument of the same name in \code{\link{qlogis}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomLogisArraySeed object.}
}
\value{
All constructors return an instance of a RandomLogisArray object,
containing random draws from a log-normal distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of log-normally distributed values.
}
\examples{
X <- RandomLogisArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomLogisArraySeed(c(1e5, 1e5), location=runif(1e5), scale=runif(1e5))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
location <- rsparsematrix(1e5, 1e5, density=0.00001)
X3 <- RandomLogisArraySeed(c(1e5, 1e5), location=location)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomBetaArray-class.R
\docType{class}
\name{RandomBetaArray-class}
\alias{RandomBetaArray-class}
\alias{RandomBetaArraySeed-class}
\alias{RandomBetaMatrix-class}
\alias{sampleDistrParam,RandomBetaArraySeed-method}
\alias{sampleDistrFun,RandomBetaArraySeed-method}
\alias{extract_array,RandomBetaArraySeed-method}
\alias{matrixClass,RandomBetaArray-method}
\alias{RandomBetaArraySeed}
\alias{DelayedArray,RandomBetaArraySeed-method}
\alias{RandomBetaArray}
\title{DelayedArray of random beta-distributed values}
\usage{
RandomBetaArraySeed(dim, shape1, shape2, ncp = 0, chunkdim = NULL)

\S4method{DelayedArray}{RandomBetaArraySeed}(seed)

RandomBetaArray(dim, shape1, shape2, ncp = 0, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{shape1, shape2, ncp}{Numeric vector used as the argument of the same name in \code{\link{qbeta}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomBetaArraySeed object.}
}
\value{
All constructors return an instance of a RandomBetaArray object,
containing random draws from a beta distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of beta-distributed values.
}
\examples{
X <- RandomBetaArraySeed(c(1e5, 1e5), shape1=1, shape2=10)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomBetaArraySeed(c(1e5, 1e5), shape1=runif(1e5), shape2=2)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
s1 <- rsparsematrix(1e5, 1e5, density=0.00001)
s1 <- abs(DelayedArray(s1)) + 1
X3 <- RandomBetaArraySeed(c(1e5, 1e5), shape1=s1, shape2=s1+1)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomPoisArray-class.R
\docType{class}
\name{RandomPoisArray-class}
\alias{RandomPoisArray-class}
\alias{RandomPoisArraySeed-class}
\alias{RandomPoisMatrix-class}
\alias{sampleDistrParam,RandomPoisArraySeed-method}
\alias{sampleDistrFun,RandomPoisArraySeed-method}
\alias{matrixClass,RandomPoisArray-method}
\alias{RandomPoisArraySeed}
\alias{DelayedArray,RandomPoisArraySeed-method}
\alias{RandomPoisArray}
\title{DelayedArray of random Poisson values}
\usage{
RandomPoisArraySeed(dim, lambda, chunkdim = NULL, sparse = FALSE)

\S4method{DelayedArray}{RandomPoisArraySeed}(seed)

RandomPoisArray(dim, lambda, chunkdim = NULL, sparse = FALSE)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{lambda}{Numeric vector used as \code{lambda} in \code{\link{qpois}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomPoisArraySeed object.}
}
\value{
All constructors return an instance of a RandomPoisArray object,
containing random draws from a Poisson distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Poisson-distributed values.
}
\examples{
X <- RandomPoisArraySeed(c(1e5, 1e5), lambda=2)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomPoisArraySeed(c(1e5, 1e5), lambda=runif(1e5), sparse=TRUE)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
lambda <- rsparsematrix(1e5, 1e5, density=0.00001)
lambda <- abs(DelayedArray(lambda)) + 0.1
X3 <- RandomPoisArraySeed(c(1e5, 1e5), lambda=lambda)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomLnormArray-class.R
\docType{class}
\name{RandomLnormArray-class}
\alias{RandomLnormArray-class}
\alias{RandomLnormArraySeed-class}
\alias{RandomLnormMatrix-class}
\alias{sampleDistrParam,RandomLnormArraySeed-method}
\alias{sampleDistrFun,RandomLnormArraySeed-method}
\alias{matrixClass,RandomLnormArray-method}
\alias{RandomLnormArraySeed}
\alias{DelayedArray,RandomLnormArraySeed-method}
\alias{RandomLnormArray}
\title{DelayedArray of random log-normal values}
\usage{
RandomLnormArraySeed(dim, meanlog = 0, sdlog = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomLnormArraySeed}(seed)

RandomLnormArray(dim, meanlog = 0, sdlog = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{meanlog, sdlog}{Numeric vector used as the argument of the same name in \code{\link{qlnorm}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomLnormArraySeed object.}
}
\value{
All constructors return an instance of a RandomLnormArray object,
containing random draws from a log-normal distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of log-normally distributed values.
}
\examples{
X <- RandomLnormArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomLnormArraySeed(c(1e5, 1e5), meanlog=runif(1e5), sdlog=runif(1e5))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
meanlog <- rsparsematrix(1e5, 1e5, density=0.00001)
X3 <- RandomLnormArraySeed(c(1e5, 1e5), meanlog=meanlog)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomNormArray-class.R
\docType{class}
\name{RandomNormArray-class}
\alias{RandomNormArray-class}
\alias{RandomNormArraySeed-class}
\alias{RandomNormMatrix-class}
\alias{sampleDistrParam,RandomNormArraySeed-method}
\alias{sampleDistrFun,RandomNormArraySeed-method}
\alias{matrixClass,RandomNormArray-method}
\alias{RandomNormArraySeed}
\alias{DelayedArray,RandomNormArraySeed-method}
\alias{RandomNormArray}
\title{DelayedArray of random normal values}
\usage{
RandomNormArraySeed(dim, mean = 0, sd = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomNormArraySeed}(seed)

RandomNormArray(dim, mean = 0, sd = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{mean, sd}{Numeric vector used as \code{mean} and \code{sd}, respectively, in \code{\link{qnorm}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomNormArraySeed object.}
}
\value{
All constructors return an instance of a RandomNormArray object,
containing random draws from a normal distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of normally distributed values.
}
\examples{
X <- RandomNormArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomNormArraySeed(c(1e5, 1e5), mean=runif(1e5), sd=runif(1e5))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
mean <- rsparsematrix(1e5, 1e5, density=0.00001)
X3 <- RandomNormArraySeed(c(1e5, 1e5), mean=mean)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomArraySeed-class.R
\docType{class}
\name{RandomArraySeed-class}
\alias{RandomArraySeed-class}
\alias{RandomArraySeed}
\alias{initialize,RandomArraySeed-method}
\alias{chunkdim,RandomArraySeed-method}
\alias{show,RandomArraySeed-method}
\alias{extract_array,RandomArraySeed-method}
\alias{is_sparse,RandomArraySeed-method}
\alias{extract_sparse_array,RandomArraySeed-method}
\alias{sampleDistrFun}
\alias{sampleDistrParam}
\title{A DelayedArray seed supplying chunked random values}
\description{
The RandomArraySeed is a \linkS4class{DelayedArray} seed that performs reproducible, on-demand sampling of randomly distributed values.
Note that this is a virtual class; the intention is to define concrete subclasses corresponding to specific parameterized distributions.
}
\section{Chunking dimensions}{

The array is conceptually partitioned into contiguous chunks of the same shape.
The random values in each chunk are initialized with a different seed and stream via the PCG32 pseudo-random number generator (see the \pkg{dqrng} package for details).
This design allows us to rapidly access any given subarray without having to do jump-aheads from the start of the stream.

The default chunking dimensions are set to the square root of the array dimensions - or 100, whichever is larger.
This scheme provides decent though suboptimal performance along any dimension.
If the access pattern is known beforehand, a better chunking scheme can often be chosen and passed to the \code{chunkdim} argument.

Note that changing the chunking dimensions will change the ordering of array values, even if the seeds are unchanged.
This may be unexpected, given that chunking in real datasets will never change the data, only the performance of access operations.
However, it is largely unavoidable in this context as the random number stream is rearranged within the array.

The \code{\link{chunkdim}(x)} method will return the chunk dimensions of a RandomArraySeed instance \code{x}.
This will be used by the \pkg{DelayedArray} machinery to optimize block processing by extracting whole chunks where possible.
}

\section{Implementing subclasses}{

To sample from a specific distribution, we can implement a concrete subclass of the RandomArraySeed.
This is done by implementing methods for \code{sampleDistrFun} and \code{sampleDistrParam}.

In the code chunks below, \code{x} is an instance of a RandomArraySeed subclass:
\itemize{
\item \code{sampleDistrFun(x)} returns a quantile function that accepts a vector of cumulative probabilities \code{p} and returns a numeric vector of quantiles.
A typical example is \code{\link{qnorm}}, though similar functions from the \pkg{stats} package can also be used.
The output vector should be the same length as \code{p}; any other distributional parameters should be recycled to the length of \code{p}.
\item \code{sampleDistrParam(x)} returns a character vector specifying the names of the distributional parameters as slots of \code{x}.
For example, for a subclass that samples from a normal distribution, this might be \code{"mean"} and \code{"sd"}.
Each distributional parameter is expected to be numeric. 
}

The \code{extract_array} method for the RandomArraySeed will automatically use both of the above methods to sample from the specified distribution.
This is achieved by randomly sampling from a standard uniform distribution, treating the values as probabilities and converting them into quantiles.
}

\section{Distributional parameters}{

Distributional parameters are passed to the relevant quantile function to obtain a random value from the desired distribution.
Each parameter can be:
\itemize{
\item A numeric scalar, which is used throughout the array.
\item A numeric vector, which is recycled along the length of the array.
This traverses the array along the first dimension, then the second, then the third, and so on;
for matrices, this is equivalent to column-major ordering.
\item A numeric array-like object of the same dimensions as \code{dim},
where each entry contains the parameter value for the corresponding entry of the output array.
This can be another \linkS4class{DelayedArray} object.
}
}

\section{Representing sparsity}{

For certain distributions, we may expect a large number of zeroes in the random output.
We provide the \emph{option} to treat the sampled values as being sparse, by setting \code{sparse=TRUE} in the constructors of the relevant subclasses.
This is optional as most distributions will not yield sparse arrays for most of their possible parameter space.

When \code{sparse=TRUE}, the block processing machinery in \pkg{DelayedArray} will return a sparse array. 
This gives downstream applications the opportunity to use more efficient sparse algorithms when relevant.
However, this option does not affect the sampling itself; the result is always the same as a dense array, just that the output is coerced into a \linkS4class{SVT_SparseArray}.

We can determine whether a RandomArraySeed \code{x} has a sparse interpretation with \code{is_sparse(x)}.
}

\seealso{
The \linkS4class{RandomUnifArraySeed} class, which implements sampling from a uniform distribution.

The \linkS4class{RandomPoisArraySeed} class, which implements sampling from a Poisson distribution.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomTArray-class.R
\docType{class}
\name{RandomTArray-class}
\alias{RandomTArray-class}
\alias{RandomTArraySeed-class}
\alias{RandomTMatrix-class}
\alias{sampleDistrParam,RandomTArraySeed-method}
\alias{sampleDistrFun,RandomTArraySeed-method}
\alias{matrixClass,RandomTArray-method}
\alias{extract_array,RandomTArraySeed-method}
\alias{RandomTArraySeed}
\alias{DelayedArray,RandomTArraySeed-method}
\alias{RandomTArray}
\title{DelayedArray of random F-distributed values}
\usage{
RandomTArraySeed(dim, df, ncp, chunkdim = NULL)

\S4method{DelayedArray}{RandomTArraySeed}(seed)

RandomTArray(dim, df, ncp, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{df, ncp}{Numeric vector used as the argument of the same name in \code{\link{qf}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.

If \code{ncp} is missing, a central T distribution is assumed.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomTArraySeed object.}
}
\value{
All constructors return an instance of a RandomTArray object,
containing random draws from a exponential distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of F-distributed values.
}
\examples{
X <- RandomTArraySeed(c(1e5, 1e5), df=10)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomTArraySeed(c(1e5, 1e5), df=sample(20, 1e5, replace=TRUE))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
ncp <- rsparsematrix(1e5, 1e5, density=0.00001)
ncp <- abs(DelayedArray(ncp)) + 1
X3 <- RandomTArraySeed(c(1e5, 1e5), df=10, ncp=ncp)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomGeomArray-class.R
\docType{class}
\name{RandomGeomArray-class}
\alias{RandomGeomArray-class}
\alias{RandomGeomArraySeed-class}
\alias{RandomGeomMatrix-class}
\alias{sampleDistrParam,RandomGeomArraySeed-method}
\alias{sampleDistrFun,RandomGeomArraySeed-method}
\alias{matrixClass,RandomGeomArray-method}
\alias{RandomGeomArraySeed}
\alias{DelayedArray,RandomGeomArraySeed-method}
\alias{RandomGeomArray}
\title{DelayedArray of random geometric-distributed values}
\usage{
RandomGeomArraySeed(dim, prob, chunkdim = NULL, sparse = FALSE)

\S4method{DelayedArray}{RandomGeomArraySeed}(seed)

RandomGeomArray(dim, prob, chunkdim = NULL, sparse = FALSE)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{prob}{Numeric vector used as \code{prob} in \code{\link{qgeom}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomGeomArraySeed object.}
}
\value{
All constructors return an instance of a RandomGeomArray object,
containing random draws from a geometric distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of geometric-distributed values.
}
\examples{
X <- RandomGeomArraySeed(c(1e5, 1e5), prob=0.5)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomGeomArraySeed(c(1e5, 1e5), prob=runif(1e5, 0, 0.1), sparse=TRUE)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
prob <- RandomUnifArray(c(1e5, 1e5))
X3 <- RandomGeomArraySeed(c(1e5, 1e5), prob=prob)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomGammaArray-class.R
\docType{class}
\name{RandomGammaArray-class}
\alias{RandomGammaArray-class}
\alias{RandomGammaArraySeed-class}
\alias{RandomGammaMatrix-class}
\alias{sampleDistrParam,RandomGammaArraySeed-method}
\alias{sampleDistrFun,RandomGammaArraySeed-method}
\alias{matrixClass,RandomGammaArray-method}
\alias{RandomGammaArraySeed}
\alias{DelayedArray,RandomGammaArraySeed-method}
\alias{RandomGammaArray}
\title{DelayedArray of random gamma-distributed values}
\usage{
RandomGammaArraySeed(dim, shape, rate = 1, scale = 1/rate, chunkdim = NULL)

\S4method{DelayedArray}{RandomGammaArraySeed}(seed)

RandomGammaArray(dim, shape, rate = 1, scale = 1/rate, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{shape, rate, scale}{Numeric vector used as the argument of the same name in \code{\link{qgamma}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.

If \code{scale} is explicitly supplied, \code{rate} is ignored.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomGammaArraySeed object.}
}
\value{
All constructors return an instance of a RandomGammaArray object,
containing random draws from a gamma distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of gamma-distributed values.
}
\examples{
X <- RandomGammaArraySeed(c(1e5, 1e5), shape=1, rate=10)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomGammaArraySeed(c(1e5, 1e5), shape=runif(1e5), rate=2)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
s1 <- rsparsematrix(1e5, 1e5, density=0.00001)
s1 <- abs(DelayedArray(s1)) + 1
X3 <- RandomGammaArraySeed(c(1e5, 1e5), shape=s1, rate=s1+1)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomExpArray-class.R
\docType{class}
\name{RandomExpArray-class}
\alias{RandomExpArray-class}
\alias{RandomExpArraySeed-class}
\alias{RandomExpMatrix-class}
\alias{sampleDistrParam,RandomExpArraySeed-method}
\alias{sampleDistrFun,RandomExpArraySeed-method}
\alias{matrixClass,RandomExpArray-method}
\alias{RandomExpArraySeed}
\alias{DelayedArray,RandomExpArraySeed-method}
\alias{RandomExpArray}
\title{DelayedArray of random exponential values}
\usage{
RandomExpArraySeed(dim, rate = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomExpArraySeed}(seed)

RandomExpArray(dim, rate = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{rate}{Numeric vector used as \code{rate} in \code{\link{qexp}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomExpArraySeed object.}
}
\value{
All constructors return an instance of a RandomExpArray object,
containing random draws from a exponential distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of exponentially distributed values.
}
\examples{
X <- RandomExpArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomExpArraySeed(c(1e5, 1e5), rate=runif(1e5))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
rate <- rsparsematrix(1e5, 1e5, density=0.00001)
rate <- abs(DelayedArray(rate)) + 1
X3 <- RandomExpArraySeed(c(1e5, 1e5), rate=rate)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomNbinomArray-class.R
\docType{class}
\name{RandomNbinomArray-class}
\alias{RandomNbinomArray-class}
\alias{RandomNbinomArraySeed-class}
\alias{RandomNbinomMatrix-class}
\alias{sampleDistrParam,RandomNbinomArraySeed-method}
\alias{sampleDistrFun,RandomNbinomArraySeed-method}
\alias{matrixClass,RandomNbinomArray-method}
\alias{extract_array,RandomNbinomArraySeed-method}
\alias{RandomNbinomArraySeed}
\alias{DelayedArray,RandomNbinomArraySeed-method}
\alias{RandomNbinomArray}
\title{DelayedArray of random negative binomial values}
\usage{
RandomNbinomArraySeed(
  dim,
  prob = prob,
  size = size,
  mu = mu,
  chunkdim = NULL,
  sparse = FALSE
)

\S4method{DelayedArray}{RandomNbinomArraySeed}(seed)

RandomNbinomArray(dim, prob, size, mu, chunkdim = NULL, sparse = FALSE)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{prob, size, mu}{Numeric vector used as the argument of the same name in \code{\link{qnbinom}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.

Exactly one of \code{prob} or \code{mu} should be supplied.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomNbinomArraySeed object.}
}
\value{
All constructors return an instance of a RandomNbinomArray object,
containing random draws from a negative binomial distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of negative binomial-distributed values.
}
\examples{
X <- RandomNbinomArraySeed(c(1e5, 1e5), size=10, mu=20)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomNbinomArraySeed(c(1e5, 1e5), size=10, mu=runif(1e5), sparse=TRUE)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
lambda <- rsparsematrix(1e5, 1e5, density=0.00001)
lambda <- abs(DelayedArray(lambda)) + 0.1
X3 <- RandomNbinomArraySeed(c(1e5, 1e5), size=1, mu=lambda)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomCauchyArray-class.R
\docType{class}
\name{RandomCauchyArray-class}
\alias{RandomCauchyArray-class}
\alias{RandomCauchyArraySeed-class}
\alias{RandomCauchyMatrix-class}
\alias{sampleDistrParam,RandomCauchyArraySeed-method}
\alias{sampleDistrFun,RandomCauchyArraySeed-method}
\alias{matrixClass,RandomCauchyArray-method}
\alias{RandomCauchyArraySeed}
\alias{DelayedArray,RandomCauchyArraySeed-method}
\alias{RandomCauchyArray}
\title{DelayedArray of random Cauchy-distributed values}
\usage{
RandomCauchyArraySeed(dim, location = 0, scale = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomCauchyArraySeed}(seed)

RandomCauchyArray(dim, location = 0, scale = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{location, scale}{Numeric vector used as the argument of the same name in \code{\link{qcauchy}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomCauchyArraySeed object.}
}
\value{
All constructors return an instance of a RandomCauchyArray object,
containing random draws from a Cauchy distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Cauchy-distributed values.
}
\examples{
X <- RandomCauchyArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomCauchyArraySeed(c(1e5, 1e5), location=runif(1e5))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
loc <- rsparsematrix(1e5, 1e5, density=0.00001)
X3 <- RandomCauchyArraySeed(c(1e5, 1e5), location=loc)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomFArray-class.R
\docType{class}
\name{RandomFArray-class}
\alias{RandomFArray-class}
\alias{RandomFArraySeed-class}
\alias{RandomFMatrix-class}
\alias{sampleDistrParam,RandomFArraySeed-method}
\alias{sampleDistrFun,RandomFArraySeed-method}
\alias{matrixClass,RandomFArray-method}
\alias{extract_array,RandomFArraySeed-method}
\alias{RandomFArraySeed}
\alias{DelayedArray,RandomFArraySeed-method}
\alias{RandomFArray}
\title{DelayedArray of random F-distributed values}
\usage{
RandomFArraySeed(dim, df1, df2, ncp, chunkdim = NULL)

\S4method{DelayedArray}{RandomFArraySeed}(seed)

RandomFArray(dim, df1, df2, ncp, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{df1, df2, ncp}{Numeric vector used as the argument of the same name in \code{\link{qf}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.

If \code{ncp} is missing, a central F distribution is assumed.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomFArraySeed object.}
}
\value{
All constructors return an instance of a RandomFArray object,
containing random draws from a exponential distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of F-distributed values.
}
\examples{
X <- RandomFArraySeed(c(1e5, 1e5), df1=1, df2=10)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomFArraySeed(c(1e5, 1e5), df1=runif(1e5)*10, df2=10)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
ncp <- rsparsematrix(1e5, 1e5, density=0.00001)
ncp <- abs(DelayedArray(ncp)) + 1
X3 <- RandomFArraySeed(c(1e5, 1e5), df1=1, df2=10, ncp=ncp)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomHyperArray-class.R
\docType{class}
\name{RandomHyperArray-class}
\alias{RandomHyperArray-class}
\alias{RandomHyperArraySeed-class}
\alias{RandomHyperMatrix-class}
\alias{sampleDistrParam,RandomHyperArraySeed-method}
\alias{sampleDistrFun,RandomHyperArraySeed-method}
\alias{matrixClass,RandomHyperArray-method}
\alias{RandomHyperArraySeed}
\alias{DelayedArray,RandomHyperArraySeed-method}
\alias{RandomHyperArray}
\title{DelayedArray of random hypergeometric-distributed values}
\usage{
RandomHyperArraySeed(dim, m, n, k, chunkdim = NULL, sparse = FALSE)

\S4method{DelayedArray}{RandomHyperArraySeed}(seed)

RandomHyperArray(dim, m, n, k, chunkdim = NULL, sparse = FALSE)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{m, n, k}{Numeric vector used as the argument of the same name in \code{\link{qhyper}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomHyperArraySeed object.}
}
\value{
All constructors return an instance of a RandomHyperArray object,
containing random draws from a hypergeometric distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of hypergeometric-distributed values.
}
\examples{
X <- RandomHyperArraySeed(c(1e5, 1e5), m=10, n=20, k=15)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomHyperArraySeed(c(1e5, 1e5), m=round(runif(1e5, 10, 20)), 
    n=20, k=15, sparse=TRUE)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
m <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
X3 <- RandomHyperArraySeed(c(1e5, 1e5), m=m, n=50, k=20)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomWeibullArray-class.R
\docType{class}
\name{RandomWeibullArray-class}
\alias{RandomWeibullArray-class}
\alias{RandomWeibullArraySeed-class}
\alias{RandomWeibullMatrix-class}
\alias{sampleDistrParam,RandomWeibullArraySeed-method}
\alias{sampleDistrFun,RandomWeibullArraySeed-method}
\alias{matrixClass,RandomWeibullArray-method}
\alias{RandomWeibullArraySeed}
\alias{DelayedArray,RandomWeibullArraySeed-method}
\alias{RandomWeibullArray}
\title{DelayedArray of random Weibull-distributed values}
\usage{
RandomWeibullArraySeed(dim, shape, scale = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomWeibullArraySeed}(seed)

RandomWeibullArray(dim, shape, scale = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{shape, scale}{Numeric vector used as the argument of the same name in \code{\link{qweibull}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomWeibullArraySeed object.}
}
\value{
All constructors return an instance of a RandomWeibullArray object,
containing random draws from a Weibull distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Weibull-distributed values.
}
\examples{
X <- RandomWeibullArraySeed(c(1e5, 1e5), shape=10)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomWeibullArraySeed(c(1e5, 1e5), shape=round(runif(1e5, 10, 20)))
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
shape <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
X3 <- RandomWeibullArraySeed(c(1e5, 1e5), shape=shape)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomUnifArray-class.R
\docType{class}
\name{RandomUnifArray-class}
\alias{RandomUnifArray-class}
\alias{RandomUnifArraySeed-class}
\alias{RandomUnifMatrix-class}
\alias{sampleDistrParam,RandomUnifArraySeed-method}
\alias{sampleDistrFun,RandomUnifArraySeed-method}
\alias{matrixClass,RandomUnifArray-method}
\alias{RandomUnifArraySeed}
\alias{DelayedArray,RandomUnifArraySeed-method}
\alias{RandomUnifArray}
\title{DelayedArray of random uniform values}
\usage{
RandomUnifArraySeed(dim, min = 0, max = 1, chunkdim = NULL)

\S4method{DelayedArray}{RandomUnifArraySeed}(seed)

RandomUnifArray(dim, min = 0, max = 1, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{min, max}{Numeric vector used as \code{min} and \code{max}, respectively, in \code{\link{qunif}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomUnifArraySeed object.}
}
\value{
All constructors return an instance of a RandomUnifArray object,
containing random draws from a uniform distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of uniformly distributed values.
}
\examples{
X <- RandomUnifArraySeed(c(1e5, 1e5))
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomUnifArraySeed(c(1e5, 1e5), min=1:1e5, max=1:1e5*2)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
min <- rsparsematrix(1e5, 1e5, density=0.00001)
X3 <- RandomUnifArraySeed(c(1e5, 1e5), min=min, max=DelayedArray(min)+1)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomWilcoxArray-class.R
\docType{class}
\name{RandomWilcoxArray-class}
\alias{RandomWilcoxArray-class}
\alias{RandomWilcoxArraySeed-class}
\alias{RandomWilcoxMatrix-class}
\alias{sampleDistrParam,RandomWilcoxArraySeed-method}
\alias{sampleDistrFun,RandomWilcoxArraySeed-method}
\alias{matrixClass,RandomWilcoxArray-method}
\alias{RandomWilcoxArraySeed}
\alias{DelayedArray,RandomWilcoxArraySeed-method}
\alias{RandomWilcoxArray}
\title{DelayedArray of random Wilcoxon-distributed values}
\usage{
RandomWilcoxArraySeed(dim, m, n, chunkdim = NULL, sparse = FALSE)

\S4method{DelayedArray}{RandomWilcoxArraySeed}(seed)

RandomWilcoxArray(dim, m, n, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{m, n}{Numeric vector used as the argument of the same name in \code{\link{qwilcox}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomWilcoxArraySeed object.}
}
\value{
All constructors return an instance of a RandomWilcoxArray object,
containing random draws from a Wilcox distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of Wilcoxon-distributed values.
}
\examples{
X <- RandomWilcoxArraySeed(c(1e5, 1e5), m=10, n=20)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomWilcoxArraySeed(c(1e5, 1e5), m=round(runif(1e5, 10, 20)), n=20)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
m <- round(RandomUnifArray(c(1e5, 1e5), 10, 20))
X3 <- RandomWilcoxArraySeed(c(1e5, 1e5), m=m, n=50)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomChisqArray-class.R
\docType{class}
\name{RandomChisqArray-class}
\alias{RandomChisqArray-class}
\alias{RandomChisqArraySeed-class}
\alias{RandomChisqMatrix-class}
\alias{sampleDistrParam,RandomChisqArraySeed-method}
\alias{sampleDistrFun,RandomChisqArraySeed-method}
\alias{matrixClass,RandomChisqArray-method}
\alias{extract_array,RandomChisqArraySeed-method}
\alias{RandomChisqArraySeed}
\alias{DelayedArray,RandomChisqArraySeed-method}
\alias{RandomChisqArray}
\title{DelayedArray of random chi-squared-distributed values}
\usage{
RandomChisqArraySeed(dim, df, ncp = 0, chunkdim = NULL)

\S4method{DelayedArray}{RandomChisqArraySeed}(seed)

RandomChisqArray(dim, df, ncp = 0, chunkdim = NULL)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{df, ncp}{Numeric vector used as the argument of the same name in \code{\link{qchisq}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{seed}{A RandomChisqArraySeed object.}
}
\value{
All constructors return an instance of a RandomChisqArray object,
containing random draws from a chi-squared distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of chi-squared-distributed values.
}
\examples{
X <- RandomChisqArraySeed(c(1e5, 1e5), df=5)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomChisqArraySeed(c(1e5, 1e5), df=runif(1e5)*20)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
df <- rsparsematrix(1e5, 1e5, density=0.00001)
df <- abs(DelayedArray(df) + 1) * 10
X3 <- RandomChisqArraySeed(c(1e5, 1e5), df=df)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RandomBinomArray-class.R
\docType{class}
\name{RandomBinomArray-class}
\alias{RandomBinomArray-class}
\alias{RandomBinomArraySeed-class}
\alias{RandomBinomMatrix-class}
\alias{sampleDistrParam,RandomBinomArraySeed-method}
\alias{sampleDistrFun,RandomBinomArraySeed-method}
\alias{matrixClass,RandomBinomArray-method}
\alias{RandomBinomArraySeed}
\alias{DelayedArray,RandomBinomArraySeed-method}
\alias{RandomBinomArray}
\title{DelayedArray of random binomial values}
\usage{
RandomBinomArraySeed(dim, size, prob, chunkdim = NULL, sparse = FALSE)

\S4method{DelayedArray}{RandomBinomArraySeed}(seed)

RandomBinomArray(dim, size, prob, chunkdim = NULL, sparse = FALSE)
}
\arguments{
\item{dim}{Integer vector of positive length, specifying the dimensions of the array.}

\item{size, prob}{Numeric vector used as the argument of the same name in \code{\link{qbinom}}.
Alternatively, a numeric array-like object with the same dimensions as \code{dim}.}

\item{chunkdim}{Integer vector of length equal to \code{dim}, containing the dimensions of each chunk.}

\item{sparse}{Logical scalar indicating whether the sampled array should be treated as sparse.}

\item{seed}{A RandomBinomArraySeed object.}
}
\value{
All constructors return an instance of a RandomBinomArray object,
containing random draws from a binomial distribution with the specified parameters.
}
\description{
A \linkS4class{DelayedArray} subclass that performs on-the-fly sampling of binomial-distributed values.
}
\examples{
X <- RandomBinomArraySeed(c(1e5, 1e5), size=10, prob=0.5)
Y <- DelayedArray(X)
Y

# Fiddling with the distribution parameters:
X2 <- RandomBinomArraySeed(c(1e5, 1e5), size=10, 
    prob=runif(1e5, 0, 0.1), sparse=TRUE)
Y2 <- DelayedArray(X2)
Y2

# Using another array as input:
library(Matrix)
size <- rsparsematrix(1e5, 1e5, density=0.00001)
size <- round(abs(DelayedArray(size)) * 10)
X3 <- RandomBinomArraySeed(c(1e5, 1e5), size=size, prob=0.5)
Y3 <- DelayedArray(X3)
Y3

}
\seealso{
The \linkS4class{RandomArraySeed} class, for details on chunking and the distributional parameters.
}
\author{
Aaron Lun
}
